'use strict';
// jQuery is a dependency, but it is loaded separately
// so projects that already include it don't load it twice

/* eslint-disable no-unused-vars */
// import bootstrap from 'bootstrap';
/* eslint-disable no-unused-vars */

import attachFastClick from 'fastclick';

// Include Modernizr
import 'conditionizr';
import 'modernizr'; 

// Include Bootstrap Components
//import 'bootstrap.affix';
//import 'bootstrap.alert';
//import 'bootstrap.button';
//import 'bootstrap.carousel';
//import 'bootstrap.dropdown';
//import 'bootstrap.modal';
//import 'bootstrap.tab';
//import 'bootstrap.transition';

import 'bootstrap.tooltip';
import 'bootstrap.popover';
import 'bootstrap.scrollspy';

// Anaconda Components
window.anaconda = window.anaconda || {};

window.anaconda = (function ($, window, document) {
  "use strict";

  var anaconda = {},
    components = {
      documentReady: [],
      documentReadyDeferred: [],
      windowLoad: [],
      windowLoadDeferred: []
    };

  $(document).ready(documentReady);
  $(window).on("load", windowLoad);

  function documentReady(context) {
    
    context = typeof context === typeof undefined ? $ : context;
    components.documentReady.concat(components.documentReadyDeferred).forEach(function (component) {
      component(context);
    });
    
    if(typeof attachFastClick != 'undefined') attachFastClick(document.body);
    
  }

  function windowLoad(context) {

    context = typeof context === "object" ? $ : context;
    components.windowLoad.concat(components.windowLoadDeferred).forEach(function (component) {
      component(context);
    });
  }

  anaconda.setContext = function (contextSelector) {
    var context = $;
    if (typeof contextSelector !== typeof undefined) {
      return function (selector) {
        return $(contextSelector).find(selector);
      };
    }
    return context;
  };

  anaconda.components = components;
  anaconda.documentReady = documentReady;
  anaconda.windowLoad = windowLoad;

  return anaconda;
}(jQuery, window, document));


//////////////// Utility Functions
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";
  anaconda.util = {};

  anaconda.util.requestAnimationFrame = window.requestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.msRequestAnimationFrame;

  anaconda.util.documentReady = function ($) {
    var today = new Date();
    var year = today.getFullYear();
    $('.update-year').text(year);
  };

  anaconda.util.getURLParameter = function (name) {
    return decodeURIComponent((new RegExp('[?|&]' + name + '=' + '([^&;]+?)(&|#|;|$)').exec(location.search) || [undefined, ""])[1].replace(/\+/g, '%20')) || null;
  };


  anaconda.util.capitaliseFirstLetter = function (string) {
    return string.charAt(0).toUpperCase() + string.slice(1);
  };

  anaconda.util.slugify = function (text, spacesOnly) {
    if (typeof spacesOnly !== typeof undefined) {
      return text.replace(/ +/g, '');
    } else {
      return text
        .toLowerCase()
        .replace(/[\~\!\@\#\$\%\^\&\*\(\)\-\_\=\+\]\[\}\{\'\"\;\\\:\?\/\>\<\.\,]+/g, '')
        .replace(/ +/g, '-');
    }
  };

  anaconda.util.sortChildrenByText = function (parentElement, reverse) {
    var $parentElement = $(parentElement);
    var items = $parentElement.children().get();
    var order = -1;
    var order2 = 1;
    if (typeof reverse !== typeof undefined) {
      order = 1;
      order2 = -1;
    }

    items.sort(function (a, b) {
      var keyA = $(a).text();
      var keyB = $(b).text();

      if (keyA < keyB) return order;
      if (keyA > keyB) return order2;
      return 0;
    });

    // Append back into place
    $parentElement.empty();
    $(items).each(function (i, itm) {
      $parentElement.append(itm);
    });
  };

  // Set data-src attribute of element from src to be restored later
  anaconda.util.idleSrc = function (context, selector) {

    selector = (typeof selector !== typeof undefined) ? selector : '';
    var elems = context.is(selector + '[src]') ? context : context.find(selector + '[src]');

    elems.each(function (index, elem) {
      elem = $(elem);
      var currentSrc = elem.attr('src'),
        dataSrc = elem.attr('data-src');

      // If there is no data-src, save current source to it
      if (typeof dataSrc === typeof undefined) {
        elem.attr('data-src', currentSrc);
      }

      // Clear the src attribute
      elem.attr('src', '');

    });
  };

  // Set src attribute of element from its data-src where it was temporarily stored earlier
  anaconda.util.activateIdleSrc = function (context, selector) {

    selector = (typeof selector !== typeof undefined) ? selector : '';
    var elems = context.is(selector + '[src]') ? context : context.find(selector + '[src]');

    elems.each(function (index, elem) {
      elem = $(elem);
      var dataSrc = elem.attr('data-src');

      // If there is no data-src, save current source to it
      if (typeof dataSrc !== typeof undefined) {
        elem.attr('src', dataSrc);
      }
    });
  };

  anaconda.util.pauseVideo = function (context) {
    var elems = context.is('video') ? context : context.find('video');

    elems.each(function (index, video) {
      var playingVideo = $(video).get(0);
      playingVideo.pause();
    });
  };

  // Take a text value in either px (eg. 150px) or vh (eg. 65vh) and return a number in pixels.
  anaconda.util.parsePixels = function (text) {
    var windowHeight = $(window).height(),
      value;

    // Text text against regular expression for px value.
    if (/^[1-9]{1}[0-9]*[p][x]$/.test(text)) {
      return parseInt(text.replace('px', ''), 10);
    }
    // Otherwise it is vh value.
    else if (/^[1-9]{1}[0-9]*[v][h]$/.test(text)) {
      value = parseInt(text.replace('vh', ''), 10);
      // Return conversion to percentage of window height.
      return windowHeight * (value / 100);
    } else {
      // If it is not proper text, return -1 to indicate bad value.
      return -1;
    }
  };

  anaconda.components.documentReady.push(anaconda.util.documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Window Functions
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  anaconda.window = {};
  anaconda.window.height = $(window).height();
  anaconda.window.width = $(window).width();

  $(window).on('resize', function () {
    anaconda.window.height = $(window).height();
    anaconda.window.width = $(window).width();
  });

  return anaconda;
}(anaconda, jQuery, window, document));


//////////////// Scroll Functions
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";


  anaconda.scroll = {};
  var raf = window.requestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.msRequestAnimationFrame;
  anaconda.scroll.listeners = [];
  anaconda.scroll.busy = false;
  anaconda.scroll.y = 0;
  anaconda.scroll.x = 0;

  var documentReady = function ($) {

    //////////////// Capture Scroll Event and fire scroll function
    jQuery(window).off('scroll.anaconda');
    jQuery(window).on('scroll.anaconda', function (evt) {
      if (anaconda.scroll.busy === false) {

        anaconda.scroll.busy = true;
        raf(function (evt) {
          anaconda.scroll.update(evt);
        });

      }
      if (evt.stopPropagation) {
        evt.stopPropagation();
      }
    });

  };

  anaconda.scroll.update = function (event) {

    if (anaconda.scroll.listeners.length > 0) {
      for (var i = 0, l = anaconda.scroll.listeners.length; i < l; i++) {
        anaconda.scroll.listeners[i](event);
      }
    }

  };

  anaconda.scroll.documentReady = documentReady;

  anaconda.components.documentReady.push(documentReady);

  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Scroll Class Modifier
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  anaconda.scroll.classModifiers = {};
  // Globally accessible list of elements/rules
  anaconda.scroll.classModifiers.rules = [];

  anaconda.scroll.classModifiers.parseScrollRules = function (element) {
    var text = element.attr('data-scroll-class'),
      rules = text.split(";");

    rules.forEach(function (rule) {
      var ruleComponents, scrollPoint, ruleObject = {};
      ruleComponents = rule.replace(/\s/g, "").split(':');
      if (ruleComponents.length === 2) {
        var rule1 = ruleComponents[0];
        if (rule1 == 'this') {
          rule1 = (parseInt(element.offset().top) + parseInt(element.outerHeight())) + 'px';
        } else if ($(rule1).length > 0) {
          rule1 = parseInt($(rule1).offset().top) + 'px';
        }
        scrollPoint = anaconda.util.parsePixels(rule1);
        if (scrollPoint > -1) {
          ruleObject.scrollPoint = scrollPoint;
          if (ruleComponents[1].length) {
            var toggleClass = ruleComponents[1];
            ruleObject.toggleClass = toggleClass;
            // Set variable in object to indicate that element already has class applied
            ruleObject.hasClass = element.hasClass(toggleClass);
            ruleObject.element = element.get(0);
            anaconda.scroll.classModifiers.rules.push(ruleObject);
          } else {
            // Error: toggleClass component does not exist.
            //console.log('Error - toggle class not found.');
            return false;
          }
        } else {
          // Error: scrollpoint component was malformed
          //console.log('Error - Scrollpoint not found.');
          return false;
        }
      }
    });

    if (anaconda.scroll.classModifiers.rules.length) {
      return true;
    } else {
      return false;
    }
  };

  anaconda.scroll.classModifiers.update = function (event) {
    var currentScroll = anaconda.scroll.y,
      scrollRules = anaconda.scroll.classModifiers.rules,
      l = scrollRules.length,
      currentRule;

    // Given the current scrollPoint, check for necessary changes 
    while (l--) {

      currentRule = scrollRules[l];

      if (currentScroll > currentRule.scrollPoint && !currentRule.hasClass) {
        // Set local copy and glogal copy at the same time;
        currentRule.element.classList.add(currentRule.toggleClass);
        currentRule.hasClass = anaconda.scroll.classModifiers.rules[l].hasClass = true;
      }
      if (currentScroll < currentRule.scrollPoint && currentRule.hasClass) {
        // Set local copy and glogal copy at the same time;
        currentRule.element.classList.remove(currentRule.toggleClass);
        currentRule.hasClass = anaconda.scroll.classModifiers.rules[l].hasClass = false;
      }
    }
  };

  var fixedElementSizes = function () {
    $('.main-container [data-scroll-class*="pos-fixed"]').each(function () {
      var element = $(this);
      element.css('max-width', element.parent().outerWidth());
      element.parent().css('min-height', element.outerHeight());
    });
  };

  var documentReady = function ($) {
    // Collect info on all elements that require class modification at load time
    // Each element has data-scroll-class with a formatted value to represent class to add/remove at a particular scroll point.
    $('[data-scroll-class]').each(function () {
      var element = $(this);

      // Test the rules to be added to an array of rules.
      if (!anaconda.scroll.classModifiers.parseScrollRules(element)) {
        console.log('Error parsing scroll rules on: ' + element);
      }
    });

    // For 'position fixed' elements, give them a max-width for correct fixing behaviour
    fixedElementSizes();
    $(window).on('resize', fixedElementSizes);

    // If there are valid scroll rules add classModifiers update function to the scroll event processing queue.
    if (anaconda.scroll.classModifiers.rules.length) {
      anaconda.scroll.listeners.push(anaconda.scroll.classModifiers.update);
    }
  };

  anaconda.components.documentReady.push(documentReady);
  anaconda.scroll.classModifiers.documentReady = documentReady;



  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Accordions
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    $('.accordion-title, [data-accordion]').on('click', function (e) {
      e.preventDefault();
      var accordion = $(this).closest('.accordion');
      var li = $(this).closest('li');
      if ($(this).attr('data-accordion')) {
        var target = $(this).attr('data-accordion');
        if ($(target).length > 0) {
          accordion = $(target);
          li = accordion.find('li').first();
        }
      }
      if (li.hasClass('active')) {
        li.removeClass('active');
      } else {
        if (accordion.hasClass('accordion--oneopen')) {
          var wasActive = accordion.find('li.active');
          wasActive.removeClass('active');
          li.addClass('active');
        } else {
          li.addClass('active');
        }
      }
    });

    $('.accordion').each(function () {
      var accordion = $(this);
      // var minHeight = accordion.outerHeight(true);
      // accordion.css('min-height',minHeight);
    });
  };

  anaconda.accordions = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));

//////////////// Alerts
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    $('.alert-close').on('click touchstart', function () {
      jQuery(this).closest('.alert').addClass('alert-dismissed');
    });
  };

  anaconda.alerts = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Backgrounds
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {

    //////////////// Append .img-bg-container <img>'s as CSS backgrounds

    $('.img-bg-container').each(function () {
      var imgSrc = $(this).children('img').attr('src');
      $(this).css('background', 'url("' + imgSrc + '")').css('background-position', 'initial').css('opacity', '1');
    });
  };

  anaconda.backgrounds = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Bars
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    $('.nav-container .bar[data-scroll-class*="fixed"]:not(.bar-absolute)').each(function () {
      var bar = $(this),
        barHeight = bar.outerHeight(true);
      bar.closest('.nav-container').css('min-height', barHeight);
    });
  };

  anaconda.bars = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Dropdowns
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";
  anaconda.dropdowns = {};
  anaconda.dropdowns.done = false;

  var documentReady = function ($) {

    var rtl = false,
      maxW = 768,
      leaveInterval = '';

    if ($('html[dir="rtl"]').length) {
      rtl = true;
    }

    if (!anaconda.dropdowns.done) {

      jQuery(document).on('click', 'body.dropdowns-hover-lg .dropdown, body:not(.dropdowns-hover) .dropdown:not(.dropdown-hover), body.dropdowns-hover .dropdown.dropdown-click', function (event) {
        if ((event.type == 'mouseenter' || event.type == 'mouseleave') && $(window).width() < maxW) {
          return false;
        }
        var dropdown = jQuery(this);

        if (jQuery(event.target).is('.dropdown-active > .dropdown-trigger')) {
          dropdown.siblings().removeClass('dropdown-active').find('.dropdown').removeClass('dropdown-active');
          dropdown.toggleClass('dropdown-active');
        } else {
          $('.dropdown-active').removeClass('dropdown-active');
          dropdown.addClass('dropdown-active');
        }

      });
      jQuery(document).on('click touchstart', 'body', function (event) {
        if (!jQuery(event.target).is('[class*="dropdown"], [class*="dropdown"] *')) {
          $('.dropdown-active').removeClass('dropdown-active');
        }
      });

      $(window).on('resize', function () {
        if ($('body').hasClass('dropdowns-hover-lg') && $(window).width() < maxW) {
          $('.dropdown-active').removeClass('dropdown-active').find('.dropdown').removeClass('dropdown-active');
        }
      });

      // Append a container to the body for measuring purposes
      jQuery('body').append('<div class="container containerMeasure" style="opacity:0;pointer-events:none;"></div>');


      // Menu dropdown positioning
      if (rtl === false) {
        repositionDropdowns($);
        jQuery(window).on('resize', function () {
          repositionDropdowns($);
        });
      } else {
        repositionDropdownsRtl($);
        jQuery(window).on('resize', function () {
          repositionDropdownsRtl($);
        });
      }

      anaconda.dropdowns.done = true;
    }
  };

  function repositionDropdowns($) {
    $('.dropdown-container').each(function () {
      var container, containerOffset, masterOffset, menuItem, content;

      jQuery(this).css('left', '');

      container = jQuery(this);
      containerOffset = container.offset().left;
      masterOffset = jQuery('.containerMeasure').offset().left;
      menuItem = container.closest('.dropdown').offset().left;
      content = null;

      container.css('left', ((-containerOffset) + (masterOffset)));

      if (container.find('.dropdown-content:not([class*="md-12"])').length) {
        content = container.find('.dropdown-content');
        content.css('left', ((menuItem) - (masterOffset)));
      }

    });
    $('.dropdown-content').each(function () {
      var dropdown, offset, width, offsetRight, winWidth, leftCorrect;

      dropdown = jQuery(this);
      offset = dropdown.offset().left;
      width = dropdown.outerWidth(true);
      offsetRight = offset + width;
      winWidth = jQuery(window).outerWidth(true);
      leftCorrect = jQuery('.containerMeasure').outerWidth() - width;

      if (offsetRight > winWidth) {
        dropdown.css('left', leftCorrect);
      }

    });
  }

  function repositionDropdownsRtl($) {

    var windowWidth = jQuery(window).width();

    $('.dropdown-container').each(function () {
      var container, containerOffset, masterOffset, menuItem, content;

      jQuery(this).css('left', '');

      container = jQuery(this);
      containerOffset = windowWidth - (container.offset().left + container.outerWidth(true));
      masterOffset = jQuery('.containerMeasure').offset().left;
      menuItem = windowWidth - (container.closest('.dropdown').offset().left + container.closest('.dropdown').outerWidth(true));
      content = null;

      container.css('right', ((-containerOffset) + (masterOffset)));

      if (container.find('.dropdown-content:not([class*="md-12"])').length) {
        content = container.find('.dropdown-content');
        content.css('right', ((menuItem) - (masterOffset)));
      }
    });
    $('.dropdown-content').each(function () {
      var dropdown, offset, width, offsetRight, winWidth, rightCorrect;

      dropdown = jQuery(this);
      offset = windowWidth - (dropdown.offset().left + dropdown.outerWidth(true));
      width = dropdown.outerWidth(true);
      offsetRight = offset + width;
      winWidth = jQuery(window).outerWidth(true);
      rightCorrect = jQuery('.containerMeasure').outerWidth() - width;

      if (offsetRight > winWidth) {
        dropdown.css('right', rightCorrect);
      }

    });
  }

  anaconda.dropdowns.documentReady = documentReady;


  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Forms
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  anaconda.forms = {};

  var documentReady = function ($) {

    //////////////// Checkbox Inputs

    $('.input-checkbox').on('click', function () {
      var checkbox = $(this);
      checkbox.toggleClass('checked');

      var input = checkbox.find('input');
      if (input.prop('checked') === false) {
        input.prop('checked', true);
      } else {
        input.prop('checked', false);
      }
      input.trigger('change');
      return false;
    });

    //////////////// Radio Buttons

    $('.input-radio').on('click', function (e) {
      if ($(e.target).is('input')) {
        return;
      }
      var radio = $(this),
        name = radio.find('input[type=radio]').attr('name');

      radio.closest('form').find('[type=radio][name*=' + name.replace(/\[[^\]]*\]/g, '') + ']').each(function () {
        $(this).parent().removeClass('checked');
      });
      radio.addClass('checked').find('input').click().prop('checked', true);
      return false;
    });

    //////////////// Number Inputs

    $('.input-number-controls > span').on('click', function () {
      var control = jQuery(this),
        parent = control.closest('.input-number'),
        input = parent.find('input[type="number"]'),
        max = input.attr('max'),
        min = input.attr('min'),
        step = 1,
        current = parseInt(input.attr('value'), 10);

      if (parent.is('[data-step]')) {
        step = parseInt(parent.attr('data-step'), 10);
      }

      if (control.hasClass('input-number-increase')) {
        if ((current + step) <= max) {
          input.attr('value', current + step);
        }
      } else {
        if ((current - step) >= min) {
          input.attr('value', current - step);
        }
      }
    });


    //////////////// File Uploads

    $('.input-file .btn').on('click', function () {
      $(this).siblings('input').trigger('click');
      return false;
    });

    //////////////// Handle Form Submit

    $('form.form-email, form[action*="list-manage.com"], form[action*="createsend.com"]').attr('novalidate', true).off('submit').on('submit', anaconda.forms.submit);

    //////////////// Handle Form Submit
    $(document).on('change, input, paste, keyup', '.attempted-submit .field-error', function () {
      $(this).removeClass('field-error');
    });

  };

  anaconda.forms.documentReady = documentReady;

  anaconda.forms.submit = function (e) {
    // return false so form submits through jQuery rather than reloading page.
    if (e.preventDefault) e.preventDefault();
    else e.returnValue = false;

    var body = $('body'),
      thisForm = $(e.target).closest('form'),
      formAction = typeof thisForm.attr('action') !== typeof undefined ? thisForm.attr('action') : "",
      submitButton = thisForm.find('button[type="submit"], input[type="submit"]'),
      error = 0,
      originalError = thisForm.attr('original-error'),
      successRedirect, formError, formSuccess, errorText, successText;

    body.find('.form-error, .form-success').remove();
    submitButton.attr('data-text', submitButton.text());
    errorText = thisForm.attr('data-error') ? thisForm.attr('data-error') : "Please fill all fields correctly";
    successText = thisForm.attr('data-success') ? thisForm.attr('data-success') : "Thanks, we'll be in touch shortly";
    body.append('<div class="form-error" style="display: none;">' + errorText + '</div>');
    body.append('<div class="form-success" style="display: none;">' + successText + '</div>');
    formError = body.find('.form-error');
    formSuccess = body.find('.form-success');
    thisForm.addClass('attempted-submit');

    // Do this if the form is intended to be submitted to MailChimp or Campaign Monitor
    if (formAction.indexOf('createsend.com') !== -1 || formAction.indexOf('list-manage.com') !== -1) {

      console.log('Mail list form signup detected.');
      if (typeof originalError !== typeof undefined && originalError !== false) {
        formError.html(originalError);
      }

      // validateFields returns 1 on error;
      if (anaconda.forms.validateFields(thisForm) !== 1) {

        thisForm.removeClass('attempted-submit');

        // Hide the error if one was shown
        formError.fadeOut(200);
        // Create a new loading spinner in the submit button.
        submitButton.addClass('btn-loading');

        try {
          $.ajax({
            url: thisForm.attr('action'),
            crossDomain: true,
            data: thisForm.serialize(),
            method: "GET",
            cache: false,
            dataType: 'json',
            contentType: 'application/json; charset=utf-8',
            success: function (data) {
              // Request was a success, what was the response?

              if (data.result !== "success" && data.Status !== 200) {

                // Got an error from Mail Chimp or Campaign Monitor

                // Keep the current error text in a data attribute on the form
                formError.attr('original-error', formError.text());
                // Show the error with the returned error text.
                formError.html(data.msg).stop(true).fadeIn(1000);
                formSuccess.stop(true).fadeOut(1000);

                submitButton.removeClass('btn-loading');
              } else {

                // Got success from Mail Chimp or Campaign Monitor

                submitButton.removeClass('btn-loading');

                successRedirect = thisForm.attr('data-success-redirect');
                // For some browsers, if empty `successRedirect` is undefined; for others,
                // `successRedirect` is false.  Check for both.
                if (typeof successRedirect !== typeof undefined && successRedirect !== false && successRedirect !== "") {
                  window.location = successRedirect;
                } else {
                  anaconda.forms.resetForm(thisForm);
                  anaconda.forms.showFormSuccess(formSuccess, formError, 1000, 5000, 500);
                }
              }
            }
          });

        } catch (err) {
          // Keep the current error text in a data attribute on the form
          formError.attr('original-error', formError.text());
          // Show the error with the returned error text.
          formError.html(err.message);
          anaconda.forms.showFormError(formSuccess, formError, 1000, 5000, 500);

          submitButton.removeClass('btn-loading');
        }

      } else {
        // There was a validation error - show the default form error message
        anaconda.forms.showFormError(formSuccess, formError, 1000, 5000, 500);
      }
    } else {
      // If no MailChimp or Campaign Monitor form was detected then this is treated as an email form instead.
      if (typeof originalError !== typeof undefined && originalError !== false) {
        formError.text(originalError);
      }

      error = anaconda.forms.validateFields(thisForm);

      if (error === 1) {
        anaconda.forms.showFormError(formSuccess, formError, 1000, 5000, 500);
      } else {

        thisForm.removeClass('attempted-submit');

        // Hide the error if one was shown
        formError.fadeOut(200);

        // Create a new loading spinner in the submit button.
        submitButton.addClass('btn-loading');

        jQuery.ajax({
          type: "POST",
          url: "mail/mail.php",
          data: thisForm.serialize() + "&url=" + window.location.href,
          success: function (response) {
            // Swiftmailer always sends back a number representing number of emails sent.
            // If this is numeric (not Swift Mailer error text) AND greater than 0 then show success message.

            submitButton.removeClass('btn-loading');

            if ($.isNumeric(response)) {
              if (parseInt(response, 10) > 0) {
                // For some browsers, if empty 'successRedirect' is undefined; for others,
                // 'successRedirect' is false.  Check for both.
                successRedirect = thisForm.attr('data-success-redirect');
                if (typeof successRedirect !== typeof undefined && successRedirect !== false && successRedirect !== "") {
                  window.location = successRedirect;
                }

                anaconda.forms.resetForm(thisForm);
                anaconda.forms.showFormSuccess(formSuccess, formError, 1000, 5000, 500);
              }
            }
            // If error text was returned, put the text in the .form-error div and show it.
            else {
              // Keep the current error text in a data attribute on the form
              formError.attr('original-error', formError.text());
              // Show the error with the returned error text.
              formError.text(response).stop(true).fadeIn(1000);
              formSuccess.stop(true).fadeOut(1000);
            }
          },
          error: function (errorObject, errorText, errorHTTP) {
            // Keep the current error text in a data attribute on the form
            formError.attr('original-error', formError.text());
            // Show the error with the returned error text.
            formError.text(errorHTTP).stop(true).fadeIn(1000);
            formSuccess.stop(true).fadeOut(1000);
            submitButton.removeClass('btn-loading');
          }
        });
      }
    }
    return false;
  };

  anaconda.forms.validateFields = function (form) {
    var body = $(body),
      error = false,
      originalErrorMessage,
      name;

    form = $(form);



    form.find('.validate-required[type="checkbox"]').each(function () {
      var checkbox = $(this);
      if (!$('[name="' + $(this).attr('name') + '"]:checked').length) {
        error = 1;
        name = $(this).attr('data-name') || 'check';
        checkbox.parent().addClass('field-error');
        //body.find('.form-error').text('Please tick at least one ' + name + ' box.');
      }
    });

    form.find('.validate-required, .required, [required]').not('input[type="checkbox"]').each(function () {
      if ($(this).val() === '') {
        $(this).addClass('field-error');
        error = 1;
      } else {
        $(this).removeClass('field-error');
      }
    });

    form.find('.validate-email, .email, [name*="cm-"][type="email"]').each(function () {
      if (!(/(.+)@(.+) {2,}\.(.+) {2,}/.test($(this).val()))) {
        $(this).addClass('field-error');
        error = 1;
      } else {
        $(this).removeClass('field-error');
      }
    });

    form.find('.validate-number-dash').each(function () {
      if (!(/^[0-9][0-9-]+[0-9]$/.test($(this).val()))) {
        $(this).addClass('field-error');
        error = 1;
      } else {
        $(this).removeClass('field-error');
      }
    });

    if (!form.find('.field-error').length) {
      body.find('.form-error').fadeOut(1000);
    } else {

      var firstError = $(form).find('.field-error:first');

      if (firstError.length) {
        $('html, body').stop(true).animate({
          scrollTop: (firstError.offset().top - 100)
        }, 1200, function () {
          firstError.focus();
        });
      }
    }

    return error;
  };

  anaconda.forms.showFormSuccess = function (formSuccess, formError, fadeOutError, wait, fadeOutSuccess) {

    formSuccess.stop(true).fadeIn(fadeOutError);

    formError.stop(true).fadeOut(fadeOutError);
    setTimeout(function () {
      formSuccess.stop(true).fadeOut(fadeOutSuccess);
    }, wait);
  };

  anaconda.forms.showFormError = function (formSuccess, formError, fadeOutSuccess, wait, fadeOutError) {

    formError.stop(true).fadeIn(fadeOutSuccess);

    formSuccess.stop(true).fadeOut(fadeOutSuccess);
    setTimeout(function () {
      formError.stop(true).fadeOut(fadeOutError);
    }, wait);
  };

  // Reset form to empty/default state.
  anaconda.forms.resetForm = function (form) {
    form = $(form);
    form.get(0).reset();
    form.find('.input-radio, .input-checkbox').removeClass('checked');

  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Masonry
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {

    $('.masonry').each(function () {
      var masonry = $(this);
      var masonryContainer = masonry.find('.masonry-container'),
        filters = masonry.find('.masonry-filters'),
        // data-filter-all-text can be used to set the word for "all"
        filterAllText = typeof filters.attr('data-filter-all-text') !== typeof undefined ? filters.attr('data-filter-all-text') : "All",
        filtersList;

      // If a filterable masonry item exists
      if (masonryContainer.find('.masonry-item[data-masonry-filter]').length) {

        // Create empty ul for filters
        filters.append('<ul></ul>');
        filtersList = filters.find('> ul');

        // To avoid cases where user leave filter attribute blank
        // only take items that have filter attribute
        masonryContainer.find('.masonry-item[data-masonry-filter]').each(function () {
          var masonryItem = $(this),
            filterString = masonryItem.attr('data-masonry-filter'),
            filtersArray = [];

          // If not undefined or empty
          if (typeof filterString !== typeof undefined && filterString !== "") {
            // Split tags from string into array 
            filtersArray = filterString.split(',');
          }
          jQuery(filtersArray).each(function (index, tag) {

            // Slugify the tag

            var slug = anaconda.util.slugify(tag);

            // Add the filter class to the masonry item

            masonryItem.addClass('filter-' + slug);

            // If this tag does not appear in the list already, add it
            if (!filtersList.find('[data-masonry-filter="' + slug + '"]').length) {
              filtersList.append('<li data-masonry-filter="' + slug + '">' + tag + '</li>');

            }
          });
        });

        anaconda.util.sortChildrenByText($(this).find('.masonry-filters ul'));
        // Add a filter "all" option
        filtersList.prepend('<li class="active" data-masonry-filter="*">' + filterAllText + '</li>');

      }
      //End of "if filterable masonry item exists"
    });

    $(document).on('click touchstart', '.masonry-filters li', function () {
      var masonryFilter = $(this);
      var masonryContainer = masonryFilter.closest('.masonry').find('.masonry-container');
      var filterValue = '*';
      if (masonryFilter.attr('data-masonry-filter') !== '*') {
        filterValue = '.filter-' + masonryFilter.attr('data-masonry-filter');
      }
      masonryFilter.siblings('li').removeClass('active');
      masonryFilter.addClass('active');
      masonryContainer.removeClass('masonry-animate');
      masonryContainer.on('layoutComplete', function () {
        $(this).addClass('masonry-active');
      });
      masonryContainer.isotope({
        filter: filterValue
      });

    });

  };

  var windowLoad = function () {

    $('.masonry').each(function () {
      var masonry = $(this).find('.masonry-container'),
        masonryParent = $(this),
        defaultFilter = '*';

      // Check for a default filter attribute
      if (masonryParent.is('[data-default-filter]')) {
        defaultFilter = masonryParent.attr('data-default-filter').toLowerCase();
        defaultFilter = '.filter-' + defaultFilter;
        masonryParent.find('li[data-masonry-filter]').removeClass('active');
        masonryParent.find('li[data-masonry-filter="' + masonryParent.attr("data-default-filter").toLowerCase() + '"]').addClass('active');
      }

      masonry.on('layoutComplete', function () {
        masonry.addClass('masonry-active');
      });

      masonry.isotope({
        itemSelector: '.masonry-item',
        filter: defaultFilter,
        masonry: {
          columnWidth: '.masonry-item'
        }
      });

    });
  };

  anaconda.masonry = {
    documentReady: documentReady,
    windowLoad: windowLoad
  };

  anaconda.components.documentReady.push(documentReady);
  anaconda.components.windowLoad.push(windowLoad);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Modals
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  anaconda.modals = {};

  var documentReady = function ($) {
    var allPageModals = "<div class=\"all-page-modals\"></div>",
      mainContainer = $('div.main-container');

    if (mainContainer.length) {
      jQuery(allPageModals).insertAfter(mainContainer);
      anaconda.modals.allModalsContainer = $('div.all-page-modals');
    } else {
      jQuery('body').append(allPageModals);
      anaconda.modals.allModalsContainer = jQuery('body div.all-page-modals');
    }

    $('.modal-container').each(function () {

      // Add modal close if none exists

      var modal = $(this),
        $window = $(window),
        modalContent = modal.find('.modal-content');


      if (!modal.find('.modal-close').length) {
        modal.find('.modal-content').append('<div class="modal-close modal-close-cross"></div>');
      }

      // Set modal height

      if (modalContent.attr('data-width') !== undefined) {
        var modalWidth = modalContent.attr('data-width').substr(0, modalContent.attr('data-width').indexOf('%')) * 1;
        modalContent.css('width', modalWidth + '%');
      }
      if (modalContent.attr('data-height') !== undefined) {
        var modalHeight = modalContent.attr('data-height').substr(0, modalContent.attr('data-height').indexOf('%')) * 1;
        modalContent.css('height', modalHeight + '%');
      }

      // Set iframe's src to data-src to stop autoplaying iframes
      anaconda.util.idleSrc(modal, 'iframe');

    });


    $('.modal-instance').each(function (index) {
      var modalInstance = $(this);
      var modal = modalInstance.find('.modal-container');
      var modalContent = modalInstance.find('.modal-content');
      var trigger = modalInstance.find('.modal-trigger');

      // Link modal with modal-id attribute

      trigger.attr('data-modal-index', index);
      modal.attr('data-modal-index', index);

      // Set unique id for multiple triggers

      if (typeof modal.attr('data-modal-id') !== typeof undefined) {
        trigger.attr('data-modal-id', modal.attr('data-modal-id'));
      }


      // Attach the modal to the body            
      modal = modal.detach();
      anaconda.modals.allModalsContainer.append(modal);
    });


    $('.modal-trigger').on('click', function (e) {

      var modalTrigger = $(this);
      var uniqueID, targetModal;
      // Determine if the modal id is set by user or is set programatically

      if (typeof modalTrigger.attr('data-modal-id') !== typeof undefined) {
        uniqueID = modalTrigger.attr('data-modal-id');
        targetModal = anaconda.modals.allModalsContainer.find('.modal-container[data-modal-id="' + uniqueID + '"]');
      } else {
        uniqueID = $(this).attr('data-modal-index');
        targetModal = anaconda.modals.allModalsContainer.find('.modal-container[data-modal-index="' + uniqueID + '"]');
      }

      anaconda.util.activateIdleSrc(targetModal, 'iframe');
      anaconda.modals.autoplayVideo(targetModal);

      anaconda.modals.showModal(targetModal);

      return false;
    });

    jQuery(document).on('click', '.modal-close', anaconda.modals.closeActiveModal);

    jQuery(document).keyup(function (e) {
      if (e.keyCode === 27) { // escape key maps to keycode `27`
        anaconda.modals.closeActiveModal();
      }
    });

    $('.modal-container').on('click', function (e) {
      if (e.target !== this) return;
      anaconda.modals.closeActiveModal();
    });

    // Trigger autoshow modals
    $('.modal-container[data-autoshow]').each(function () {
      var modal = $(this);
      var millisecondsDelay = modal.attr('data-autoshow') * 1;

      anaconda.util.activateIdleSrc(modal);
      anaconda.modals.autoplayVideo(modal);

    });

    // Exit modals
    $('.modal-container[data-show-on-exit]').each(function () {
      var modal = jQuery(this),
        exitSelector = modal.attr('data-show-on-exit'),
        delay = 0;

      if (modal.attr('data-delay')) {
        delay = parseInt(modal.attr('data-delay'), 10) || 0;
      }

      // If a valid selector is found, attach leave event to show modal.
      if ($(exitSelector).length) {
        modal.prepend($('<i class="ti-close close-modal">'));
        jQuery(document).on('mouseleave', exitSelector, function () {
          if (!$('.modal-active').length) {
            anaconda.modals.showModal(modal, delay);
          }
        });
      }
    });


    // Autoshow modal by ID from location href
    if (window.location.href.split('#').length === 2) {
      var modalID = window.location.href.split('#').pop();
      if ($('[data-modal-id="' + modalID + '"]').length) {
        anaconda.modals.closeActiveModal();
        anaconda.modals.showModal($('[data-modal-id="' + modalID + '"]'));
      }
    }

    // Make modal scrollable
    $(document).on('wheel mousewheel scroll', '.modal-content, .modal-content .scrollable', function (evt) {
      if (evt.preventDefault) {
        evt.preventDefault();
      }
      if (evt.stopPropagation) {
        evt.stopPropagation();
      }
      this.scrollTop += (evt.originalEvent.deltaY);
    });
  };
  ////////////////
  //////////////// End documentReady
  ////////////////

  anaconda.modals.documentReady = documentReady;

  anaconda.modals.showModal = function (modal, millisecondsDelay) {

    var delay = (typeof millisecondsDelay !== typeof undefined) ? (1 * millisecondsDelay) : 0;

    setTimeout(function () {
      $(modal).addClass('modal-active');
    }, delay);
  };

  anaconda.modals.closeActiveModal = function () {
    var modal = jQuery('body div.modal-active');
    anaconda.util.idleSrc(modal, 'iframe');
    anaconda.util.pauseVideo(modal);

    modal.removeClass('modal-active');
  };

  anaconda.modals.autoplayVideo = function (modal) {
    // If modal contains HTML5 video with autoplay, play the video
    if (modal.find('video[autoplay]').length) {
      var video = modal.find('video').get(0);
      video.play();
    }
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Popovers
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    if (typeof jQuery().popover != 'undefined') {
      $('[data-toggle="popover"]').popover();
    }
  };

  anaconda.popovers = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Flickity
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  anaconda.sliders = {};
  anaconda.sliders.draggable = true;

  var documentReady = function ($) {

    $('.slider').each(function (index) {

      var slider = $(this);
      var sliderInitializer = slider.find('ul.slides');
      sliderInitializer.find('>li').addClass('slide');
      var childnum = sliderInitializer.find('li').length;
      var arrows = false;
      var paging = false;
      var timing = 7000;
      var autoplay = true;
      var draggable = anaconda.sliders.draggable;
      if (slider.attr('data-arrows') === 'true') {
        arrows = true;
      } else {
        arrows = false;
      }
      if (slider.attr('data-autoplay') === 'false') {
        autoplay = false;
      } else {
        autoplay = true;
      }
      if (slider.attr('data-paging') === 'true' && sliderInitializer.find('li').length > 1) {
        paging = true;
      } else {
        paging = false;
      }
      if (slider.attr('data-timing')) {
        timing = slider.attr('data-timing') * 1;
      }
      // Set data attribute to inidicate the number of children in the slider
      slider.attr('data-children', childnum);

      if (childnum < 2) {
        draggable = false;
      }

      $(sliderInitializer).flickity({
        cellSelector: '.slide',
        cellAlign: 'left',
        wrapAround: true,
        pageDots: paging,
        prevNextButtons: arrows,
        autoPlay: timing,
        draggable: draggable,
        imagesLoaded: true
      });

      $(sliderInitializer).on('scroll.flickity', function (event, progress) {
        if (slider.find('.is-selected').hasClass('controls-dark')) {
          slider.addClass('controls-dark');
        } else {
          slider.removeClass('controls-dark');
        }
      });
    });

  };

  anaconda.sliders.documentReady = documentReady;

  anaconda.components.documentReadyDeferred.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Smoothscroll
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  anaconda.smoothscroll = {};
  anaconda.smoothscroll.sections = [];

  anaconda.smoothscroll.init = function () {
    anaconda.smoothscroll.sections = [];

    $('a.inner-link').each(function () {
      var sectionObject = {},
        link = $(this),
        href = link.attr('href'),
        validLink = new RegExp('^#[^\n^\s^\#^\.]+$');

      if (validLink.test(href)) {

        if ($('section' + href).length) {
          sectionObject.id = href;
          sectionObject.top = Math.round($(href).offset().top);
          sectionObject.height = Math.round($(href).outerHeight());
          sectionObject.link = link.get(0);
          sectionObject.active = false;

          anaconda.smoothscroll.sections.push(sectionObject);
        }
      }
    });

    anaconda.smoothscroll.highlight();
  };

  anaconda.smoothscroll.highlight = function () {
    anaconda.smoothscroll.sections.forEach(function (section) {
      if (anaconda.scroll.y >= section.top && anaconda.scroll.y < (section.top + section.height)) {
        if (section.active === false) {
          section.link.classList.add("inner-link-active");
          section.active = true;
        }
      } else {
        section.link.classList.remove("inner-link-active");
        section.active = false;
      }
    });
  };

  anaconda.scroll.listeners.push(anaconda.smoothscroll.highlight);

  var documentReady = function ($) {
    // Smooth scroll to inner links
    var innerLinks = $('a.inner-link');

    if (innerLinks.length) {
      innerLinks.each(function (index) {
        var link = $(this),
          href = link.attr('href');
        if (href.charAt(0) !== "#") {
          link.removeClass('inner-link');
        }
      });

      anaconda.smoothscroll.init();
      $(window).on('resize', anaconda.smoothscroll.init);

      var offset = 0;
      if ($('body[data-smooth-scroll-offset]').length) {
        offset = $('body').attr('data-smooth-scroll-offset');
        offset = offset * 1;
      }

      smoothScroll.init({
        selector: '.inner-link',
        selectorHeader: null,
        speed: 750,
        easing: 'easeInOutCubic',
        offset: offset
      });

    }

    // back to top
    $('.back-to-top').on('click', function (e) {
      e.preventDefault();
      $('html, body').stop().animate({
        'scrollTop': '0.1px'
      }, 750);
    });
  };

  anaconda.smoothscroll.documentReady = documentReady;

  anaconda.components.documentReady.push(documentReady);
  anaconda.components.windowLoad.push(anaconda.smoothscroll.init);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Scrollspy
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    /*
    $('[data-spy="scroll"]').each(function () {
      var $spy = $(this).scrollspy({ target: $(this).attr('data-target') });
    });
    */
  };

  anaconda.scrollspy = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Tabs
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    $('.tabs').each(function () {
      var tabs = $(this);
      tabs.after('<ul class="tabs-content">');
      tabs.find('li').each(function () {
        var currentTab = $(this),
          tabContent = currentTab.find('.tab-content').wrap('<li></li>').parent(),
          tabContentClone = tabContent.clone(true, true);
        tabContent.remove();
        currentTab.closest('.tabs-container').find('.tabs-content').append(tabContentClone);
      });
    });

    $('.tabs li').on('click', function (e) {
      var clickedTab = $(this),
        tabContainer = clickedTab.closest('.tabs-container'),
        activeIndex = (clickedTab.index() * 1) + (1),
        activeContent = tabContainer.find('> .tabs-content > li:nth-of-type(' + activeIndex + ')'),
        iframe, radial;

      tabContainer.find('> .tabs > li').removeClass('active');
      tabContainer.find('> .tabs-content > li').removeClass('active');

      clickedTab.addClass('active');
      activeContent.addClass('active');


      // If there is an <iframe> element in the tab, reload its content when the tab is made active.
      iframe = activeContent.find('iframe');
      if (iframe.length) {
        iframe.attr('src', iframe.attr('src'));
      }

    });

    $('.tabs li.active').trigger('click');
  };

  anaconda.tabs = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Toggle Class
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {
    $('[data-toggle-class]').each(function () {
      var element = $(this),
        data = element.attr('data-toggle-class').split("|");


      $(data).each(function () {
        var candidate = element,
          dataArray = [],
          toggleClass = '',
          toggleElement = '',
          dataArray = this.split(";");

        if (dataArray.length === 2) {
          toggleElement = dataArray[0];
          toggleClass = dataArray[1];
          $(candidate).on('click', function () {
            if (!candidate.hasClass('toggled-class')) {
              candidate.toggleClass('toggled-class');
            } else {
              candidate.removeClass('toggled-class');
            }
            $(toggleElement).toggleClass(toggleClass);
            return false;
          });
        } else {
          console.log('Error in [data-toggle-class] attribute. This attribute accepts an element, or comma separated elements terminated witha ";" followed by a class name to toggle');
        }
      });
    });
  };

  anaconda.toggleClass = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));


//////////////// Video
window.anaconda = (function (anaconda, $, window, document) {
  "use strict";

  var documentReady = function ($) {

    //////////////// Youtube Background

    if ($('.yt-bg').length) {
      $('.yt-bg').each(function () {
        var player = $(this);
        var vidURL = $(this).attr('data-video-url');
        var startAt = $(this).attr('data-start-at');
        player.attr('data-property', '{videoURL:"' + vidURL + '",containment:"self",autoPlay:true, mute:true, startAt:' + startAt + ', opacity:1}');
        player.closest('.vid-bg').append('<div class="loading-indicator"></div>');
        player.YTPlayer();
        player.on("YTPStart", function () {
          player.closest('.vid-bg').addClass('video-active');
        });
      });
    }

    if ($('.vid-bg').find('video').length) {
      $('.vid-bg').find('video').closest('.vid-bg').addClass('video-active');
    }

    //////////////// Video Cover Play Icons

    $('.video-cover').each(function () {
      var videoCover = $(this);
      if (videoCover.find('iframe').length) {
        videoCover.find('iframe').attr('data-src', videoCover.find('iframe').attr('src'));
        videoCover.find('iframe').attr('src', '');
      }
    });

    $('.video-cover .video-play-icon').on("click", function () {
      var playIcon = $(this);
      var videoCover = playIcon.closest('.video-cover');
      if (videoCover.find('video').length) {
        var video = videoCover.find('video').get(0);
        videoCover.addClass('reveal-video');
        video.play();
        return false;
      } else if (videoCover.find('iframe').length) {
        var iframe = videoCover.find('iframe');
        iframe.attr('src', iframe.attr('data-src'));
        videoCover.addClass('reveal-video');
        return false;
      }
    });
  };

  anaconda.video = {
    documentReady: documentReady
  };

  anaconda.components.documentReady.push(documentReady);
  return anaconda;

}(anaconda, jQuery, window, document));